/*


    ========== licence begin GPL
    Copyright (C) 2002-2003 SAP AG

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    ========== licence end


*/
package com.sap.dbtech.jdbc.exceptions;

/**
 * Title:        SAP DB JDBC Driver 2.0
 * Description:  Implementation of a JDBC Driver for SAP DB
 * Copyright:    Copyright (c) 2001
 * Company:      SAP AG
 * @author
 * @version 1.0
 */

public class ConnectionException extends SQLExceptionSapDB {

  /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 1L;

public ConnectionException(com.sap.dbtech.rte.comm.RTEException rteExc) {
    super ("[" + rteExc.getDetailErrorCode() + "] "
           + rteExc.getMessage(), "08000", rteExc.getDetailErrorCode(), 0);
  }
    
  public ConnectionException(SQLExceptionSapDB rteExc) {
      super (rteExc.getMessage(), "08000", rteExc.getErrorCode());

  }
  
  public boolean isConnectionReleasing()
    {
        return true;
    }
}
