/*


    ========== licence begin GPL
    Copyright (C) 2002-2003 SAP AG

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    ========== licence end


*/

package com.sap.dbtech.jdbc.packet;

/**
 *
 */
public class PartEnumeration implements java.util.Enumeration {
    int partsLeft;
    ReplyPacket replyPacket;
/**
 *
 * @param reply com.sap.dbtech.jdbc.packet.ReplyPacket
 */
PartEnumeration(ReplyPacket reply) {
    this.replyPacket = reply;
    this.partsLeft = reply.partCount ();
}
/**
 * hasMoreElements method comment.
 */
public boolean hasMoreElements() {
    return this.partsLeft > 0;
}
/**
 * nextElement method comment.
 */
public Object nextElement() {
    this.replyPacket.nextPart ();
    --this.partsLeft;
    return null;
}
/**
 *
 * @return int
 */
public int partKind () {
    return this.replyPacket.partKind ();
}
/**
 *
 * @return int
 */
int pos () {
    return this.replyPacket.partPos ();
}
}