package com.sap.dbtech.jdbc.translators;

import java.io.OutputStream;
import java.io.Writer;
import java.sql.Blob;
import java.sql.SQLException;

import com.sap.dbtech.jdbc.exceptions.NotImplemented;
import com.sap.dbtech.util.MessageKey;
import com.sap.dbtech.util.MessageTranslator;

/*

 @author d031096

 ========== licence begin GPL
    Copyright (C) 2002-2003 SAP AG

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    ========== licence end


 */
public class AbstractSimpleGetval {

    final public long position(String searchstr, long start)
            throws SQLException {
        throw new NotImplemented(MessageTranslator
                .translate(MessageKey.ERROR_POSITION_NOTIMPLEMENTED));
    }

    final public int setBytes(long pos, byte[] bytes) throws SQLException {
        throw new java.lang.UnsupportedOperationException(MessageTranslator
                .translate(MessageKey.ERROR_SETBYTES_NOTIMPLEMENTED));
    }

    final public int setBytes(long pos, byte[] bytes, int offset, int len)
            throws SQLException {
        throw new java.lang.UnsupportedOperationException(MessageTranslator
                .translate(MessageKey.ERROR_SETBYTES_NOTIMPLEMENTED));
    }

    final public OutputStream setBinaryStream(long pos) throws SQLException {
        throw new java.lang.UnsupportedOperationException(MessageTranslator
                .translate(MessageKey.ERROR_SETBINARYSTREAM_NOTIMPLEMENTED));
    }

    final public void truncate(long len) throws SQLException {
        throw new java.lang.UnsupportedOperationException(MessageTranslator
                .translate(MessageKey.ERROR_TRUNCATE_NOTIMPLEMENTED));
    }

    final public int setString(long pos, String str) throws SQLException {
        throw new java.lang.UnsupportedOperationException(MessageTranslator
                .translate(MessageKey.ERROR_SETSTRING_NOTIMPLEMENTED));
    }

    final public int setString(long pos, String str, int offset, int len)
            throws SQLException {
        throw new java.lang.UnsupportedOperationException(MessageTranslator
                .translate(MessageKey.ERROR_SETSTRING_NOTIMPLEMENTED));
    }

    final public OutputStream setAsciiStream(long pos) throws SQLException {
        /** @todo: Implement this java.sql.Clob method */
        throw new java.lang.UnsupportedOperationException(MessageTranslator
                .translate(MessageKey.ERROR_SETASCIISTREAM_NOTIMPLEMENTED));
    }

    final public Writer setCharacterStream(long pos) throws SQLException {
        /** @todo: Implement this java.sql.Clob method */
        throw new java.lang.UnsupportedOperationException(MessageTranslator
                .translate(MessageKey.ERROR_SETCHARACTERSTREAM_NOTIMPLEMENTED));
    }

    final public long position(java.sql.Clob lob, long start)
            throws SQLException {
        throw new NotImplemented(MessageTranslator
                .translate(MessageKey.ERROR_POSITION_NOTIMPLEMENTED));
    }

    final public long position(byte pattern[], long start) throws SQLException {
        throw new NotImplemented(MessageTranslator
                .translate(MessageKey.ERROR_POSITION_NOTIMPLEMENTED));
    }

    final public long position(Blob pattern, long start) throws SQLException {
        throw new NotImplemented(MessageTranslator
                .translate(MessageKey.ERROR_POSITION_NOTIMPLEMENTED));
    }

}
