/*


    ========== licence begin GPL
    Copyright (C) 2002-2003 SAP AG

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    ========== licence end


*/

package com.sap.dbtech.jdbcext;


import java.sql.Connection;
import java.sql.SQLException;

import javax.naming.NamingException;
import javax.naming.Reference;
import javax.naming.Referenceable;
import javax.sql.ConnectionPoolDataSource;
import javax.sql.PooledConnection;

public class ConnectionPoolDataSourceSapDB
    extends DataSourceSapDBBase
    implements ConnectionPoolDataSource, Referenceable
{
    public ConnectionPoolDataSourceSapDB()
    {}

    public PooledConnection getPooledConnection()
        throws SQLException
    {
        Connection c=openPhysicalConnection();
        return new PooledConnectionSapDB(c);
    }

    public PooledConnection getPooledConnection(String username, String password)
        throws SQLException
    {
        Connection c=openPhysicalConnection(username, password);
        return new PooledConnectionSapDB(c);
    }

    public Reference getReference() throws NamingException
    {
        return createReference(getClass().getName());
    }
    
}
