/*


    ========== licence begin GPL
    Copyright (C) 2002-2003 SAP AG

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    ========== licence end


*/

package com.sap.dbtech.vsp00;

/**
 * copy of gsp00::tsp00_LongDescBlock and related constants
 */
public abstract class LongDesc {
    // tsp00_LdbChange
    public static final int UseTermchar_C = 0;
    public static final int UseConversion_C = 1;
    public static final int UseToAscii_C = 2;
    public static final int UseUCS2_Swap_C = 3;

    // tsp00_ValMode
    public static final int DataPart_C = 0;
    public static final int AllData_C = 1;
    public static final int LastData_C = 2;
    public static final int NoData_C = 3;
    public static final int NoMoreData_C = 4;
    public static final int LastPutval_C = 5;
    public static final int DataTrunc_C = 6;
    public static final int Close_C = 7;
    public static final int Error_C = 8;
    public static final int StartposInvalid_C = 9;

    // infoset
    public static final int ExTrigger_C = 1;
    public static final int WithLock_C = 2;
    public static final int NoCLose_C = 4;
    public static final int NewRec_C = 8;
    public static final int IsComment_C = 16;
    public static final int IsCatalog_C = 32;
    public static final int Unicode_C = 64;

    // state
    public static final int StateUseTermChar_C   = 1; 
    public static final int StateStream_C        = 1; 
    public static final int StateUseConversion_C = 2;
    public static final int StateUseToAscii_C    = 4;
    public static final int StateUseUcs2Swap_C   = 8;
    public static final int StateShortScol_C     = 16;
    public static final int StateFirstInsert_C   = 32;
    public static final int StateCopy_C          = 64;
    public static final int StateFirstCall_C     = 128;
    
    // tsp00_LongDescBlock = RECORD
    public static final int Descriptor_O = 0;   // c8
    public static final int Tabid_O = 8;        // c8
    public static final int MaxLen_O = 16;      // c4
    public static final int InternPos_O = 20;   // i4
    public static final int Infoset_O = 24;     // set1
    public static final int State_O = 25;   // bool
    public static final int unused1_O = 26;     // c1
    public static final int Valmode_O = 27;     // i1
    public static final int Valind_O = 28;      // i2
    public static final int unused_O = 30;      // i2
    public static final int Valpos_O = 32;      // i4;
    public static final int Vallen_O = 36;      // i4;
    public static final int Size_C = 40;
}