/*


    ========== licence begin GPL
    Copyright (C) 2002-2003 SAP AG

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    ========== licence end


*/

package com.sap.dbtech.vsp001;

/**
 * offsets of vsp001::tsp1_packet
 */
public abstract class Packet {
    public final static int MessCode_O = 0; // enum1
    public final static int MessSwap_O = 1;  // enum1
    public final static int Filler1_O  = 2; // int2
    public final static int ApplVersion_O = 4; // c5
    public final static int Appl_O     = 9; // c3
    public final static int VarpartSize_O = 12; // int4
    public final static int VarpartLen_O = 16;  // int4
    public final static int Filler2_O = 20;     // int2
    public final static int NoOfSegm_O = 22;    // int2
    public final static int Filler3_O = 24;     // c8
    public final static int Segment_O = 32;
    
 /**
  * indicators for fields with variable length
  */   
    public final static int csp1_fi_max_1byte_length_C = 245;
    public final static int csp1_fi_ignored_C          = 250;
    public final static int csp1_fi_special_null_C     = 251;
    public final static int csp1_fi_blob_description_C = 252;
    public final static int csp1_fi_default_value_C    = 253;
    public final static int csp1_fi_null_value_C       = 254;
    public final static int csp1_fi_2byte_length_C     = 255;
    
 /* 
  * property names used to identify fields
  */
    public final static String csp1_maxpasswordlen_tag_C  = "maxpasswordlen";

}