/*


    ========== licence begin GPL
    Copyright (C) 2002-2003 SAP AG

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    ========== licence end


*/

package com.sap.dbtech.vsp001;

/**
 * copies of tsp1_param_opt_type, tsp1_param_io_type, tsp1_param_info
 */
public abstract class ParamInfo {
    // param modes, declared as set values
    public static final int Mandatory_C = 1;
    public static final int Optional_C = 2;
    public static final int Default_C = 4;
    public static final int EscapeChar_C = 8;
    // param io types
    public static final int Input_C = 0;
    public static final int Output_C = 1;
    public static final int Inout_C = 2;
    // layout of tsp1_param_info
    public static final int Mode_O = 0;     // Set 1
    public static final int IoType_O = 1;   // enum 1
    public static final int DataType_O = 2; // enum1
    public static final int Frac_O = 3;     // int1
    public static final int Length_O = 4;   // int2
    public static final int InOutLen_O = 6; // int2
    public static final int Bufpos_O = 8;   // int4
    public static final int Param_no_O  = 8;    // int2
    public static final int read_only_0 = 10;   // int1
    public static final int serial_0    = 11;   // int1
    /** The size of tsp1_param_info */
    public static final int ParamInfo_END_O_C = 12;
}