/*


    ========== licence begin GPL
    Copyright (C) 2002-2003 SAP AG

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    ========== licence end


*/

package com.sap.dbtech.vsp001;

/**
 * offsets of vsp001::tsp1_segment
 */
public abstract class Segment {
    // common header
    public static final int Len_O = 0;  // int4
    public static final int Offs_O = 4; // int4
    public static final int NoOfParts_O = 8;    // int2
    public static final int OwnIndex_O = 10;    // int2
    public static final int SegmKind_O = 12;    // enum1
    // request segment
    public static final int MessType_O = 13;    // enum1
    public static final int SqlMode_O = 14;     // enum1
    public static final int Producer_O = 15;    // enum1
    public static final int CommitImmediateley_O = 16;  // bool
    public static final int IgnoreCostwarning_O = 17;   // bool
    public static final int Prepare_O = 18;             // bool
    public static final int WithInfo_O = 19;            // bool
    public static final int MassCmd_O = 20;             // bool
    public static final int ParsingAgain_O = 21;        // bool
    public static final int CommandOptions_O = 22;        // enum1
    // reply segment
    public static final int SqlState_O = 13;    // c5
    public static final int Returncode_O = 18;  // int2
    public static final int ErrorPos_O = 20;    // int4
    public static final int ExternWarning_O = 24;   // set2
    public static final int InternWarning_O = 26;   // set2
    public static final int FunctionCode_O = 28;    // int2
    public static final int TraceLevel_O = 30;      // int1
    public static final int Part_O = 40;
}